//File		:part02_28.cs
//Purpose	:Demonstrate basic inheritance
//

using System;

public class Dog {

	//Common attributes
	public string Name;
	public int    Weight;


	//Common methods
	public virtual void Speak( ) { Console.WriteLine("ruff!"); }
	public void DrinkWater( ) { Console.WriteLine("Gulp"); }

}


//A specialized version of a Dog
public class GermanShepard : Dog {
	
	public void OnGuard( ) { Console.WriteLine("In Guard Mode"); }

	//override the Dog.Speak() method
	public override void Speak( ) { Console.WriteLine("RUFF,RUFF,RUFF"); }
}


public class JackRussell : Dog {
	public void Chew( ) { Console.WriteLine("I'm chewing your favorite shoes!"); }

	//override the Dog.Speak() method
	public override void Speak( ) { Console.WriteLine("yap,yap,yap"); }

}





public class Inherit {

	public static void Main( ) {
		
		GermanShepard Simon = new GermanShepard( );
		JackRussell Daisy   = new JackRussell( );

		//Both Simon and Daisy have a name and weight
		Simon.Name = "Simon"; Simon.Weight = 85;
		Daisy.Name = "Daisy"; Daisy.Weight = 25;

		//Polymorphism allows for the proper method to be called
		//based on runtime type information
		Dog d = Simon;
		d.Speak( );		//calls GermanShepard.Speak( );

		d = Daisy;
		d.Speak( );		//calls JackRussell.Speak( );

	}
}

